// This file is generated by kconfig_compiler_kf5 from pocketsphinxconfig.kcfg.
// All changes you do to this file will be lost.
#ifndef POCKETSPHINXCONFIG_H
#define POCKETSPHINXCONFIG_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <plugin-config.h>

class PocketSphinxConfig : public KConfigSkeleton
{
  public:

    static PocketSphinxConfig *self();
    ~PocketSphinxConfig() override;

    /**
      Set Directory containing acoustic model files
    */
    static
    void setAcousticModelPath( const QString & v )
    {
      if (!self()->isAcousticModelPathImmutable())
        self()->mAcousticModelPath = v;
    }

    /**
      Get Directory containing acoustic model files
    */
    static
    QString acousticModelPath()
    {
      return self()->mAcousticModelPath;
    }

    /**
      Is Directory containing acoustic model files Immutable
    */
    static
    bool isAcousticModelPathImmutable()
    {
      return self()->isImmutable( QStringLiteral( "acousticModelPath" ) );
    }

    /**
      Set Word trigram language model input file
    */
    static
    void setTrigramModelFile( const QString & v )
    {
      if (!self()->isTrigramModelFileImmutable())
        self()->mTrigramModelFile = v;
    }

    /**
      Get Word trigram language model input file
    */
    static
    QString trigramModelFile()
    {
      return self()->mTrigramModelFile;
    }

    /**
      Is Word trigram language model input file Immutable
    */
    static
    bool isTrigramModelFileImmutable()
    {
      return self()->isImmutable( QStringLiteral( "trigramModelFile" ) );
    }

    /**
      Set Main pronunciation dictionary (lexicon) input file
    */
    static
    void setLexiconFile( const QString & v )
    {
      if (!self()->isLexiconFileImmutable())
        self()->mLexiconFile = v;
    }

    /**
      Get Main pronunciation dictionary (lexicon) input file
    */
    static
    QString lexiconFile()
    {
      return self()->mLexiconFile;
    }

    /**
      Is Main pronunciation dictionary (lexicon) input file Immutable
    */
    static
    bool isLexiconFileImmutable()
    {
      return self()->isImmutable( QStringLiteral( "lexiconFile" ) );
    }

    /**
      Set Num of silence frames to keep after speech to silence transition
    */
    static
    void setVadPostSpeech( int v )
    {
      if (!self()->isVadPostSpeechImmutable())
        self()->mVadPostSpeech = v;
    }

    /**
      Get Num of silence frames to keep after speech to silence transition
    */
    static
    int vadPostSpeech()
    {
      return self()->mVadPostSpeech;
    }

    /**
      Is Num of silence frames to keep after speech to silence transition Immutable
    */
    static
    bool isVadPostSpeechImmutable()
    {
      return self()->isImmutable( QStringLiteral( "vadPostSpeech" ) );
    }

    /**
      Set Num of speech frames to keep before silence to speech transition
    */
    static
    void setVadPreSpeech( int v )
    {
      if (!self()->isVadPreSpeechImmutable())
        self()->mVadPreSpeech = v;
    }

    /**
      Get Num of speech frames to keep before silence to speech transition
    */
    static
    int vadPreSpeech()
    {
      return self()->mVadPreSpeech;
    }

    /**
      Is Num of speech frames to keep before silence to speech transition Immutable
    */
    static
    bool isVadPreSpeechImmutable()
    {
      return self()->isImmutable( QStringLiteral( "vadPreSpeech" ) );
    }

    /**
      Set Num of speech frames to trigger VAD from silence to speech
    */
    static
    void setVadStartSpeech( int v )
    {
      if (!self()->isVadStartSpeechImmutable())
        self()->mVadStartSpeech = v;
    }

    /**
      Get Num of speech frames to trigger VAD from silence to speech
    */
    static
    int vadStartSpeech()
    {
      return self()->mVadStartSpeech;
    }

    /**
      Is Num of speech frames to trigger VAD from silence to speech Immutable
    */
    static
    bool isVadStartSpeechImmutable()
    {
      return self()->isImmutable( QStringLiteral( "vadStartSpeech" ) );
    }

    /**
      Set Threshold for decision between noise and silence frames. Log-ratio between signal level and noise level
    */
    static
    void setVadTreshold( double v )
    {
      if (!self()->isVadTresholdImmutable())
        self()->mVadTreshold = v;
    }

    /**
      Get Threshold for decision between noise and silence frames. Log-ratio between signal level and noise level
    */
    static
    double vadTreshold()
    {
      return self()->mVadTreshold;
    }

    /**
      Is Threshold for decision between noise and silence frames. Log-ratio between signal level and noise level Immutable
    */
    static
    bool isVadTresholdImmutable()
    {
      return self()->isImmutable( QStringLiteral( "vadTreshold" ) );
    }

  protected:
    PocketSphinxConfig();
    friend class PocketSphinxConfigHelper;


    // PocketSphinx
    QString mAcousticModelPath;
    QString mTrigramModelFile;
    QString mLexiconFile;
    int mVadPostSpeech;
    int mVadPreSpeech;
    int mVadStartSpeech;
    double mVadTreshold;

  private:
};

#endif

